﻿local function Usable(button)
    local action = button.action
    local isUsable, notEnoughMana = IsUsableAction(action)
    local icon = button.icon
    local count = GetActionCount(action)

    if isUsable then
        icon:SetVertexColor(1.0, 1.0, 1.0, 1.0)
        icon:SetDesaturated(false)
    elseif notEnoughMana then
        icon:SetVertexColor(0.3, 0.3, 0.3, 1.0)
        icon:SetDesaturated(true)
    elseif (IsConsumableAction(action) or IsStackableAction(action)) and count == 0 then
        icon:SetVertexColor(0.4, 0.4, 0.4, 1.0)
        icon:SetDesaturated(true)
    else
        if UnitExists("target") then
            icon:SetVertexColor(0.4, 0.4, 0.4, 1.0)
            icon:SetDesaturated(true)
        else
            icon:SetVertexColor(1.0, 1.0, 1.0, 1.0)
            icon:SetDesaturated(false)
        end
    end
end

local function RangeIndicator(self)
    local _, oom = IsUsableAction(self.action)
    local valid = IsActionInRange(self.action);
    local checksRange = (valid ~= nil);
    local inRange = checksRange and valid;

    -- if self.HotKey and self.HotKey:GetAlpha() > 0 then
    --     self.HotKey:SetAlpha(0)
    -- end
    if checksRange and not inRange then
        if oom then
            self.icon:SetVertexColor(0.3, 0.3, 0.3, 1.0)
            self.icon:SetDesaturated(true)
        else
            self.icon:SetVertexColor(1.0, 0.35, 0.35, 0.9)
            self.icon:SetDesaturated(true)
        end
    else
        Usable(self)
    end
end

local addonName = ...
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript(
  "OnEvent",
  function(self, event, arg1)
    if (addonName == arg1) then

        if (GoodmanUIDB.ACTIONBARS.HIDE_GRYPHONS) then
            MainMenuBarLeftEndCap:Hide()
            MainMenuBarRightEndCap:Hide()
        end

        hooksecurefunc("ActionButton_OnUpdate", RangeIndicator)
    end
end)