GoodmanUIDB = {
}

function printTable(t, s)
    for k, v in pairs(t) do
        local kfmt = '["' .. tostring(k) .. '"]'
        if type(k) ~= "string" then
            kfmt = "[" .. k .. "]"
        end
        local vfmt = '"' .. tostring(v) .. '"'
        if type(v) == "table" then
            printTable(v, (s or "") .. kfmt)
        else
            if type(v) ~= "string" then
                vfmt = tostring(v)
            end
            print(type(t) .. (s or "") .. kfmt .. " = " .. vfmt)
        end
    end
end

defaultOptions = {
    TEXTURES_PATH = "Interface\\AddOns\\GoodmanUI\\textures",
    COLOR = .35,
    ACTIONBARS = {
        HIDE_HOTKEYS = false,
        HIDE_MACRONAMES = false,
        HIDE_GRYPHONS = false,
    },
    GENERAL = {
        LUA_ERRORS = false
    },
    AUTOMATION = {
        SELL_JUNK = true
    },
    RAIDFRAMES = {
        SCALE = 1.0,
        SOLO = false
    },
}

local function copyDefaults(src, dst)
    if type(src) ~= "table" then
        return {}
    end
    if type(dst) ~= "table" then
        dst = {}
    end
    for k, v in pairs(src) do
        if type(v) == "table" then
            dst[k] = copyDefaults(v, dst[k])
        elseif type(v) ~= type(dst[k]) then
            dst[k] = v
        end
    end
    return dst
end


local addonName = ...
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript(
  "OnEvent",
  function(self, event, arg1)
    if (addonName == arg1) then
        GoodmanUIDB = copyDefaults(defaultOptions, GoodmanUIDB)
    end
end)

GoodmanUIDB = copyDefaults(defaultOptions, GoodmanUIDB)
